/**
  Generated Main Source File

  Company:
    Microchip Technology Inc.

  File Name:
    main.c

  Summary:
    This is the main file generated using PIC10 / PIC12 / PIC16 / PIC18 MCUs

  Description:
    This header file provides implementations for driver APIs for all modules selected in the GUI.
    Generation Information :
        Product Revision  :  PIC10 / PIC12 / PIC16 / PIC18 MCUs - 1.81.6
        Device            :  PIC18F27Q10
        Driver Version    :  2.00
*/

/*
    (c) 2018 Microchip Technology Inc. and its subsidiaries. 
    
    Subject to your compliance with these terms, you may use Microchip software and any 
    derivatives exclusively with Microchip products. It is your responsibility to comply with third party 
    license terms applicable to your use of third party software (including open source software) that 
    may accompany Microchip software.
    
    THIS SOFTWARE IS SUPPLIED BY MICROCHIP "AS IS". NO WARRANTIES, WHETHER 
    EXPRESS, IMPLIED OR STATUTORY, APPLY TO THIS SOFTWARE, INCLUDING ANY 
    IMPLIED WARRANTIES OF NON-INFRINGEMENT, MERCHANTABILITY, AND FITNESS 
    FOR A PARTICULAR PURPOSE.
    
    IN NO EVENT WILL MICROCHIP BE LIABLE FOR ANY INDIRECT, SPECIAL, PUNITIVE, 
    INCIDENTAL OR CONSEQUENTIAL LOSS, DAMAGE, COST OR EXPENSE OF ANY KIND 
    WHATSOEVER RELATED TO THE SOFTWARE, HOWEVER CAUSED, EVEN IF MICROCHIP 
    HAS BEEN ADVISED OF THE POSSIBILITY OR THE DAMAGES ARE FORESEEABLE. TO 
    THE FULLEST EXTENT ALLOWED BY LAW, MICROCHIP'S TOTAL LIABILITY ON ALL 
    CLAIMS IN ANY WAY RELATED TO THIS SOFTWARE WILL NOT EXCEED THE AMOUNT 
    OF FEES, IF ANY, THAT YOU HAVE PAID DIRECTLY TO MICROCHIP FOR THIS 
    SOFTWARE.
 */

#include "mcc_generated_files/mcc.h"

char TEXTE[128];
char * txt;
unsigned int  i,j,k;
adc_result_t EA1=0;
unsigned int EA1F, EA1ACC;
volatile unsigned int    Timer4_Tick=0;
volatile char Timer4_Flag=0;
volatile unsigned int Max_Timer4_Ticks=1;


void CPrint(const char * Tx);
void Print(char * Tx);
void CRLF1(void);

void CPrint(const char * Tx)
{ int i=0;
   while(*(Tx)>0)
   {
       EUSART1_Write(*(Tx++));
       i++;
       if (i>80) break;
       
   }   
}

void Print(char * Tx)
{ int i=0;
   while(*(Tx)>0)
   {
       EUSART1_Write(*(Tx++));
         i++;
       if (i>80) break;
       
   }   
}
  void CRLF1()
  {
      EUSART1_Write(13); EUSART1_Write(10);
  }
  
   
void UART1_Write(uint8_t txData)
{
       TX1REG = txData;
       __delay_ms(1);
}  
  

 //                        Main application

void main(void)
{
    // Initialize the device
    SYSTEM_Initialize();
    INTERRUPT_GlobalInterruptEnable();
    // Disable the Global Interrupts
    //INTERRUPT_GlobalInterruptDisable();
    INTERRUPT_PeripheralInterruptEnable();
    // Disable the Peripheral Interrupts
    //INTERRUPT_PeripheralInterruptDisable();

    Timer4_Tick=0;
     Timer4_Flag=0;
     Max_Timer4_Ticks=10;
     
    for (i=0;i<sizeof(TEXTE);i++) TEXTE[i]=0;
     EA1F=0;
     EA1ACC=0;
     ADCC_ClearAccumulator();
     ADCC_SetRepeatCount(8);
        
    IO_RA5_SetLow() ;
    IO_RA4_SetHigh() ;
    for (i=0;i<4;i++)
    {
       IO_RA4_Toggle()  ;
      __delay_ms(150);
        IO_RA5_Toggle()  ;
        __delay_ms(150);  
                  
    }
     IO_RA4_SetLow() ;
     IO_RA5_SetLow() ;
         __delay_ms(1000);
     txt =&TEXTE[0];
    // ADCC_Initialize();
    EUSART1_Initialize();
    CRLF1();
    CRLF1();
   
    txt =&TEXTE[0];
     
     CRLF1();
     CPrint("\r\n Projet MPLABX : \r\n \r\n");
     CPrint(" Directory : C:\\MPLABX_Projects\\P18F27Q10_tests_UART1_ADC_I2C_SPI.X \r\n"); 
     CPrint(" Projet : P18F27Q10_tests_UART1_ADC_I2C_SPI\r\n");
     CPrint(" Compilation le  ");
     Print(__DATE__);
     CPrint(" at ");
     Print( __TIME__); CPrint(" UTC ,");
     sprintf(txt, "avec version XC8 : %5d \r\n",__XC8_VERSION);
     Print(txt);
     
    // CPrint(" Start Timer4 Initialise a 1sec (HFINTOSC 31KHz  PR4=242 Diviseurs 64 x 2=128 \r\n \
    //   Timer4_Ticks=10 => 10 sec delay r\n");
     
      CPrint(" Start Timer4 Initialise a LFINTOSC 31Khz PR4=241 Diviseurs= 64*2=128 => 1sec \r\n \
       Timer4_Ticks=10 => 1x10 = 10sec delay r\n");
 
     Timer4_Tick=0;
     Timer4_Flag=0;
     Max_Timer4_Ticks=10;
     TMR4_StartTimer();
     j=0;
     do
     { 
         j++;
     } while(Timer4_Flag==0); 
     k=sprintf(txt,"  Read Timer4 = %5d Timer4_Tick= %5d j=%5d \r\n",TMR4_Counter8BitGet(),Timer4_Tick,j);
    Print(txt);
     
     

     txt =&TEXTE[0];
      CRLF1();
     CPrint(" Test sur Carte BASE 18F27Q10 \r\n");
     CPrint(" UART1 TX sur RC6 19200,8,N,1\r\n");
     CPrint(" Analog sur EA1\r\n");
  
     CPrint(" Change FOSC TMR4 -> LFINTOSC 31Khz\r\n");
     TMR4_Set_Fosc(1);
     T4CON = 0b01111111; // Prescaler=1:128 et postscaler=1:16 =>  2048   8mS
     Max_Timer4_Ticks=62;
     TMR4_LoadPeriodRegister(250); 
     TMR4_StartTimer();// 32 mS
     CPrint(" Elapsed time (FOSC/4 PR4=250  Maxticks=62 -> 2 secondes \r\n");
   
    
     
    IO_RA5_SetLow() ;
        __delay_ms(1000);
         CRLF1();
          UART1_Write('A');
            UART1_Write('B');
              UART1_Write('C');
              CRLF1();
    j=0;
    do
    {
       IO_RA4_Toggle()  ;
     // __delay_ms(1000);
       EA1=ADCC_GetSingleConversion(1);
     //  EA1ACC= ADCC_GetAccumulatorValue();
     //  EA1F= ADCC_GetFilterValue();
       j++;
       if (j<64 ) EUSART1_Write(32+j); else j=0;
       if (j%16==0)  CRLF1(); 
       TEXTE[0]=0; 
       txt =&TEXTE[0];
       //k=sprintf(txt,"  j= %5d EA1= %5d  EA1ACC= %5d EA1F= %5d\r\n",j,EA1,EA1ACC,EA1F);
       k=sprintf(txt,"  j= %5d EA1= %5d \r\n",j,EA1);
       Print(txt);
       
      TMR4_StartTimer();// 32 mS * Nb Tick
      while(Timer4_Flag==0);
      
    }while (1);
}
/**
 End of File
*/


/*
 
(0.000)  Projet MPLABX : 
(0.000)  
(0.000)  Directory : C:\MPLABX_Projects\P18F27Q10_tests_UART1_ADC_I2C_SPI.X 
(0.000)  Projet : P18F27Q10_tests_UART1_ADC_I2C_SPI
(0.000)  Compilation le  Dec  5 2020 at 16:18:10 UTC ,avec version XC8 :  2100 
(0.000)  Start Timer4 Initialise a LFINTOSC 31Khz PR4=241 Diviseurs= 64*2=128 => 1sec 
(0.027)    Read Timer4 =     0 Timer4_Tick=    10 j=-10606 
(10.002) 
(0.000)  Test sur Carte BASE 18F27Q10 
(0.031)  UART1 TX sur RC6 19200,8,N,1
(0.000)  Analog sur EA1
(0.015)  Change FOSC TMR4 -> LFINTOSC 31Khz
(0.017)  Elapsed time (FOSC/4 PR4=250  Maxticks=62 -> 2 secondes 
(0.955) 
ABC
(0.008) !  j=     1 EA1=  1023 
(1.990) "  j=     2 EA1=  1023 
(1.997) #  j=     3 EA1=  1023 
(1.996) $  j=     4 EA1=  1023 
(1.998) %  j=     5 EA1=  1023 

 */